# Inserting the general libraries 
Sketchup::require 'RS_Window/Resources/Libraries/StringArrayHash_Functions_Lib'	; include RubyWindow::StringArrayHash_Functions_Lib
Sketchup::require 'RS_Window/Resources/Libraries/Numeric_Functions_Lib'			; include RubyWindow::Numeric_Functions_Lib
Sketchup::require 'RS_Window/Resources/Libraries/Drawing_Functions_Lib'			; include RubyWindow::Drawing_Functions_Lib
Sketchup::require 'RS_Window/Resources/Libraries/XML_Functions_Lib'				; include RubyWindow::XML_Functions_Lib
Sketchup::require 'RS_Window/Resources/Libraries/Language_Class_Lib'			; include RubyWindow::RW_Language_Class_Lib
Sketchup::require 'RS_Window/Resources/Libraries/Mac_Address_Lib'				; include RubyWindow::Mac_Address_Lib

# Then insert the application .rb files 
Sketchup::require 'RS_Window/RubyWindow_Settings_Class'			; include RubyWindow::RubyWindow_Settings_Class
Sketchup::require 'RS_Window/RubyWindow_Project_Settings_Class'	; include RubyWindow::RubyWindow_Project_Settings_Class
Sketchup::require 'RS_Window/RubyWindow_Menus'					; include RubyWindow::RubyWindow_Menus
Sketchup::require 'RS_Window/User_Class'						; include RubyWindow::User_Class
Sketchup::require 'RS_Window/User_Register'						; include RubyWindow::User_Register
Sketchup::require 'RS_Window/Configuration' 					; include RubyWindow::Configuration
Sketchup::require 'RS_Window/Project_Settings'					; include RubyWindow::Project_Settings
Sketchup::require 'RS_Window/Tables_Class'						; include RubyWindow::Tables_Class
Sketchup::require 'RS_Window/Language_TEXT'						; include RubyWindow::Language_TEXT
Sketchup::require 'RS_Window/SetofProfiles_Class'				; include RubyWindow::SetofProfiles_Class
Sketchup::require 'RS_Window/Planing_Profiles_Class'			; include RubyWindow::Planing_Profiles_Class
Sketchup::require 'RS_Window/Fillings_Class'					; include RubyWindow::Fillings_Class
Sketchup::require 'RS_Window/Surfaces_Class' 					; include RubyWindow::Surfaces_Class
Sketchup::require 'RS_Window/Surface_Class' 					; include RubyWindow::Surface_Class
Sketchup::require 'RS_Window/Windowframe_Class' 				; include RubyWindow::Windowframe_Class
Sketchup::require 'RS_Window/Windowframes_edit'					; include RubyWindow::Windowframes_edit
Sketchup::require 'RS_Window/Windowframes_import'				; include RubyWindow::Windowframes_import
Sketchup::require 'RS_Window/Matrix_Importer'					; include RubyWindow::Matrix_Importer
Sketchup::require 'RS_Window/Analyse_Functions'					; include RubyWindow::Analyse_Functions
Sketchup::require 'RS_Window/Color_Table_Class'					; include RubyWindow::Color_Table_Class
Sketchup::require 'RS_Window/Color_Edit'						; include RubyWindow::Color_Edit
Sketchup::require 'RS_Window/Language_converter'				; include RubyWindow::Language_Converter
#Sketchup::require 'RS_Window/RubyWindow_Safer_Observer_Events'	; include RubyWindow::RubyWindow_Safer_Observer_Events

module RubyWindow

# Environment settings for application and project
RubyWindow_Settings = RubyWindow_Environment.new("3.0")
RubyWindow_Project_Settings = RubyWindow_Project_Environment.new()

# Then, read the configuration file
RubyWindow_Config_Load(RubyWindow_Settings.config_file)

start_activate_rubywindow() if RubyWindow_Settings.start_tries < 9

#if !RubyWindow_Settings.trial_expired
	# Turn on the Ruby Console
	if RubyWindow_Settings.ruby_console == "On"
		Sketchup.send_action "showRubyPanel:"
	end

	RubyWindow_Settings.licence = RW_User.new(RubyWindow_Settings.licence_key, RubyWindow_Settings.organisation)

	RubyWindow_Settings.language = RubySoft_Language.new(RubyWindow_Settings.path_language, RubyWindow_Settings.filename_language, RubyWindow_Settings.language_code)
	RubyWindow_Settings.profiles = RubyWindow_PlaningProfiles.new(RubyWindow_Settings.file_profiles, false)
	RubyWindow_Project_Settings_Read(false) 
	RubyWindow_Settings.fillings = RubyWindow_Fillings.new(RubyWindow_Settings.file_fillings, false)
	RubyWindow_Settings.surfaces = RubyWindow_Surfaces.new(RubyWindow_Settings.file_surfaces, false)
	RubyWindow_Settings.colors 	 = RubyWindow_Colors.new(RubyWindow_Settings.file_colors)

#end

Start_Menu()

end # end of module