module RubyWindow
module User_Class
class RW_User 
	attr_reader		:dag, :maand, :jaar, :eeuw, :versie, :afgifte, :mac_key,
					:organisatie, :expired, 
					:trial, :lite, :full, :bim
	
	def initialize(sleutel=false, organisatie="")
		if sleutel
			#puts "Sleutel is: #{sleutel.inspect}"
			fout_code = self.validate_key(sleutel, true)
			if fout_code != 0
				if fout_code == 7
					RubyWindow_Settings.mac_address = RS_Mac_Address(RubyWindow_Settings.applicatie_user_directory, RubyWindow_Settings.is_mac, RubyWindow_Settings.mac_address)
					UI.messagebox([	"Sorry! But for using our latest version you require a new serial number,", "\n\n", 
									"Please send us an e-mail at renewal220@rubysoft.eu from the address you registerd and we will send you the key as soon as possible (and still for trial).", "\n", 
									"\n", "Add this Key: #{RubyWindow_Settings.mac_address} and Pin-code: #{RubyWindow_Settings.id} in the subject of your e-mail", "\n", 
									"\nThank you for using RubyWindow!"], 
									MB_MULTILINE, "RubyWindow")
				else
					UI.messagebox("RubyWindow - Key validation: FAILED! (##{fout_code})")
				end
				sleutel = false
				#raise Exception.new("Key validation: FAILED! (##{fout_code})")
			else
				@dag	= sleutel[ 2,2]  
				@maand	= sleutel[ 6,2]  
				@jaar	= sleutel[10,2]  
				@eeuw	= sleutel[14,2]  
				@versie	= sleutel[8,1]
				
				@expired = false
				
				if !self.check_date(@eeuw+@jaar+@maand+@dag)
					@expired = true
					UI.messagebox("Your Serial-Key has expired, request a new Serial-Key at www.rubysoft.eu")
					@versie	= "0" # trial version
				elsif days_until_expiration() < 10 
					UI.messagebox("Attention!, Your RubyWindow licence expires in: #{days_until_expiration()} days")
				end
				
				@afgifte = sleutel[12,1]
			end
	#		@serial	= sleutel[0,2] + sleutel[4,2] + sleutel[9,1] + sleutel[13,1] + sleutel[16,4] 
		end
		@trial	= @versie == "0"
		@lite	= @versie == "1"
		@full	= @versie == "2"
		@bim	= @versie == "3"
		
		@organisatie = organisatie
		if !sleutel 
			if RubyWindow_Settings.start_date
				trialdays = RW_TrialDays(encript_date(RubyWindow_Settings.start_date))
				# date = encript_date(RubyWindow_Settings.start_date)
				# year	= date[0,4]
				# month	= date[4,2]
				# day		= date[6,2] 
				# trialdays = ( (Time.now-Time.gm(year.to_i, month.to_i, day.to_i)) / (60*60*24) ).to_i
				
				if trialdays > 12
					#UI.messagebox(["You have used the RubyWindow Extension for SketchUp for 10 days.","\n",
					#				"We hope you liked it. To continue using the possibilities you need to update to our LITE or FULL version.","\n",
					#				"Please visit www.rubysoft.eu for the differences."], MB_MULTILINE)
					
					if trialdays < 20
						#go_to_Rubysoft_website("http://www.rubysoft.eu/index.php/webshop")
					end
					
					#RubyWindow_Settings.trial_expired = true
					@trial	= true
					@full	= true
				else
					if trialdays == 0
						#UI.messagebox("RubyWindow is now activated. The FULL functionality is available for the next ten days! Visit www.rubysoft.eu for more information.")
					elsif trialdays < 10
						daytxt = trialdays == 9 ? "days" : "day"
						#UI.messagebox("You have #{10-trialdays} #{daytxt} left to expirence the full functionality of RubyWindow! Visit www.rubysoft.eu for more information.")
					else
						#UI.messagebox(["You have used the RubyWindow Extension for SketchUp for 10 days.","\n",
						#				"To be able to continue creating frames, windows and doors in seconds you need to update your current version to our LITE or FULL version.","\n",
						#				"Please visit www.rubysoft.eu for the differences and pricing options."], MB_MULTILINE)
										
					end
					@trial	= true
					@full	= true
				end				
			end
			@dag	 = "31"  
			@maand	 = "10"  
			@jaar	 = "19"  
			@eeuw	 = "20" 
			@versie	 = "0"
			@afgifte = "0"
	#		@serial	= rand().to_s[-10,10] 
		end
		
		
	end
	
	def set_key
		serial_input = false
		organisatie = @organisatie
		while true
			default = serial_input || "9999-9999-9999-9999-9999"
			organisation = organisation || "" 
			result = UI.inputbox(["Serial-Key: ","E-mail: "], [default, organisatie], RWTEXT("Register licence"))
			if !result
				break
			else
				organisatie	 = result[1].strip
				serial_input = result[0]
				serial_input = self.clean_up_key(serial_input)
				fout_code = validate_key(serial_input, true) 
				if fout_code == 0
					UI.messagebox("Serial Key succesfully inserted!\n\nPlease restart Sketchup", MB_MULTILINE, "Sketchup-RubyWindow")
					RubyWindow_Settings.licence_key = serial_input
					RubyWindow_Config_Store()
					break
				else
					keuze = UI.messagebox("Key validation: FAILED! (##{fout_code})", MB_RETRYCANCEL) # 4 = Retry   2 = Cancel
					if keuze == 2
						break
					elsif serial_input.size == 20
						serial_input = " "+self.serial_key?(serial_input)
					else 
						serial_input = false
					end
				end
			end	
		end
		@organisatie = organisatie
		RubyWindow_Settings.organisation = @organisatie
		RubyWindow_Config_Store()
	end
	
	def validate_key(serial_input, mac_check = false)
		serial_input = self.clean_up_key(serial_input)
		fout = 0
		fout = 1 if serial_input.size != 20 
		fout = 2 if serial_input[12,1] != "2" # Afgegeven
		fout = 3 if serial_input[ 8,1] == "0" # Versie = trial
		fout = 4 if serial_input[ 2,2].to_i <=  0 || serial_input[ 2,2].to_i > 31 # dag 
		fout = 5 if serial_input[ 6,2].to_i <=  0 || serial_input[ 6,2].to_i > 12 # maand
		fout = 6 if serial_input[14,2].to_i < 19  || serial_input[14,2].to_i > 20 # eeuw 
		
		if fout == 0
			totaal_mac = (serial_input[0,2]+serial_input[16,2]).to_i
			totaal_serial = 0							            # 0117-2310-2414-2520-6789 Succesfull FULL
			totaal_serial += serial_input[ 4,1].to_i				# 0117-2310-1414-2520-6789 Succesfull LITE
			totaal_serial += serial_input[ 5,1].to_i				# 0119-2309-1413-2520-6789 Expired ("13 ipv "14)
			totaal_serial += serial_input[ 9,1].to_i				# 0123 4567 8901 2345 6789
			totaal_serial += serial_input[13,1].to_i				#			  11 1111 1111
			totaal_serial += serial_input[18,1].to_i
			totaal_serial += serial_input[19,1].to_i
			fout = 7 if totaal_serial != 27
		end
		
		if fout == 0 && !self.check_date(serial_input[14,2]+serial_input[10,2]+serial_input[6,2]+serial_input[2,2])
			fout = 8
		end
		
		if fout == 0 && mac_check
			RubyWindow_Settings.mac_address = RS_Mac_Address(RubyWindow_Settings.applicatie_user_directory, RubyWindow_Settings.is_mac, RubyWindow_Settings.mac_address)
			mac_adres = RubyWindow_Settings.mac_address
			if !mac_adres
				fout = 9
			else
				mac_adres = clean_up_key(mac_adres)
				if mac_adres.size != 12
					fout = 10
				else
					if totaal_mac != calculate_mac_adres(mac_adres)
						fout = 11
					end
				end
			end
		end
		
		return fout
	end
	
	def calculate_mac_adres(mac_adres)
		mac_nr = 0
		mac_adres.each_byte {|b| mac_nr += b}
		#UI.messagebox("Mac_nr = #{mac_nr} (uit: #{mac_adres})")
		return mac_nr
	end
	
	def clean_up_key(key)
		key = key.to_s
		key = key.gsub(" ","")
		key = key.gsub(":","")
		key = key.gsub(",","")
		key = key.gsub(".","")
		key = key.gsub(" ","")
		key = key.gsub("-","")
		key = key.gsub("_","")
		key = key.gsub("/","")
		key = key.gsub("'","")
		key = key.gsub('"',"")
		key = key.gsub("@","")
		key = key.gsub(";","")
		return key
	end
	def check_date(key_datum)
		time 	= Time.now
		year	= time.year.to_s
		month	= ("0"+time.month.to_s)[-2,2]
		day		= ("0"+time.day.to_s)[-2,2]
		date = year + month + day
		#puts "Key Datum: #{key_datum} => #{date}"
		if key_datum >= date
			return true
		else
			return false
		end
	end
	
	def days_until_expiration()
		return ((Time.gm((@eeuw+@jaar).to_i, @maand.to_i, @dag.to_i) - Time.now) / (60*60*24)).to_i
	end
	
	def serial_key?(key=false)
		sleutel = key || RubyWindow_Settings.licence_key
		if sleutel
			return sleutel[0,4]+"-"+sleutel[4,4]+"-"+sleutel[8,4]+"-"+sleutel[12,4]+"-"+sleutel[16,4]
		else
			return false
		end
	end
	
end
def RW_TrialDays(date)
	year	= date[0,4]
	month	= date[4,2]
	day		= date[6,2] 
	trialdays = ( (Time.now-Time.gm(year.to_i, month.to_i, day.to_i)) / (60*60*24) ).to_i
	return trialdays
end
def RW_Full?(meld = true)
	if !(RubyWindow_Settings.licence.trial || RubyWindow_Settings.licence.full)
		UI.messagebox(RWTEXT("Only available for RubyWindow Full users. (See www.RubySoft.eu)")) if meld
		return false
	end
	return true
end
def go_to_Rubysoft_website(url, meld=false)
	status = UI.openURL url
	if meld 
		if status
			UI.messagebox("URL Succesfull launched!")
		else
			UI.messagebox("URL launching failled...")
		end
	end
	# dlg = UI::WebDialog.new("RubySoft Website", true, "ShowRubySoftDotEU", 800, 800, 0, 0, true)
	# dlg.set_url url
	# dlg.show
end
end
end
